$(function(){
$("#vector-map").dxVectorMap({
maxZoomFactor: 4,
projection: {
to: function (coordinates) {
return [coordinates[0] / 100, coordinates[1] / 100];
},
from: function (coordinates) {
return [coordinates[0] * 100, coordinates[1] * 100];
}
},
layers: [{
hoverEnabled: false,
dataSource: buildingData,
name: "building"
}, {
color: "transparent",
borderWidth: 1,
label: {
enabled: true,
dataField: "name"
},
dataSource: roomsData,
name: "rooms"
}],
tooltip: {
enabled: true,
customizeTooltip: function (arg) {
if(arg.layer.name === "rooms")
return { text: "Square: " + arg.attribute("square") + " ft²" };
}
}
});
});
<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=1.0" />
<script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
<script>window.jQuery || document.write(decodeURIComponent('%3Cscript src="js/jquery.min.js"%3E%3C/script%3E'))</script>
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/20.2.5/css/dx.common.css" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/20.2.5/css/dx.light.css" />
<script src="https://cdn3.devexpress.com/jslib/20.2.5/js/dx.all.js"></script>
<script src="data.js"></script>
<link rel="stylesheet" type="text/css" href="styles.css" />
<script src="index.js"></script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<div id="vector-map"></div>
</div>
</body>
</html>
#vector-map {
height: 400px;
}
var buildingData = {
type: "FeatureCollection",
features: [
{
type: "Feature",
geometry: {
type: "Polygon",
coordinates: [[
[10, -80],
[-80, -80],
[-80, 80],
[40, 80],
[40, -20],
[100, -20],
[100, -80],
[30, -80],
[30, -74],
[34, -74],
[34, -68],
[40, -68],
[40, -74],
[94, -74],
[94, -26],
[40, -26],
[40, -60],
[34, -60],
[34, 74],
[-74, 74],
[-74, 30],
[10, 30],
[10, 24],
[-74, 24],
[-74, -24],
[10, -24],
[10, -30],
[-74, -30],
[-74, -74],
[10, -74]
]]
}
}
]
};
var roomsData = {
type: "FeatureCollection",
features: [
{
type: "Feature",
properties: {
name: "Room 1",
square: 576
},
geometry: {
type: "Polygon",
coordinates: [[
[-74, -30],
[34, -30],
[34, -74],
[-74, -74]
]]
}
}, {
type: "Feature",
properties: {
name: "Room 2",
square: 600
},
geometry: {
type: "Polygon",
coordinates: [[
[-74, 24],
[34, 24],
[34, -24],
[-74, -24]
]]
}
}, {
type: "Feature",
properties: {
name: "Room 3",
square: 540
},
geometry: {
type: "Polygon",
coordinates: [[
[-74, 74],
[34, 74],
[34, 30],
[-74, 30]
]]
}
}, {
type: "Feature",
properties: {
name: "Room 4",
square: 288
},
geometry: {
type: "Polygon",
coordinates: [[
[40, -26],
[94, -26],
[94, -74],
[40, -74]
]]
}
}
]
};

<dx-vector-map
id="vector-map"
[projection]="projection">
<dxo-tooltip
[enabled]="true"
[customizeTooltip]="customizeTooltip"></dxo-tooltip>
<dxi-layer
[hoverEnabled]="false"
[dataSource]="buildingData"
name="building"></dxi-layer>
<dxi-layer
color="transparent"
[dataSource]="roomsData"
name="rooms"
[borderWidth]="1">
<dxo-label [enabled]="true" dataField="name"></dxo-label>
</dxi-layer>
</dx-vector-map>
import { NgModule, Component, enableProdMode } from '@angular/core';
import { BrowserModule } from '@angular/platform-browser';
import { platformBrowserDynamic } from '@angular/platform-browser-dynamic';
import { DxVectorMapModule } from 'devextreme-angular';
import { FeatureCollection, Service } from './app.service';
if(!/localhost/.test(document.location.host)) {
enableProdMode();
}
@Component({
selector: 'demo-app',
providers: [ Service ],
templateUrl: 'app/app.component.html',
styleUrls: ['app/app.component.css']
})
export class AppComponent {
projection: any;
roomsData: FeatureCollection;
buildingData: FeatureCollection;
constructor(service: Service) {
this.roomsData = service.getRoomsData();
this.buildingData = service.getBuildingData();
this.projection = {
to(coordinates) {
return [coordinates[0] / 100, coordinates[1] / 100];
},
from(coordinates) {
return [coordinates[0] * 100, coordinates[1] * 100];
}
};
}
customizeTooltip(arg) {
if(arg.layer.name === "rooms")
return {
text: "Square: " + arg.attribute("square") + " ft²"
};
}
}
@NgModule({
imports: [
BrowserModule,
DxVectorMapModule
],
declarations: [AppComponent],
bootstrap: [AppComponent]
})
export class AppModule { }
platformBrowserDynamic().bootstrapModule(AppModule);
::ng-deep #vector-map {
height: 400px;
}
import { Injectable } from '@angular/core';
export class FeatureCollection {
type: string;
features: Feature[];
}
export class Feature {
type: string;
properties?: FeatureProperty;
geometry: FeatureGeometry;
}
export class FeatureProperty {
name: string;
square?: number;
}
export class FeatureGeometry {
type: string;
coordinates: number[][][];
}
let buildingData: FeatureCollection = {
type: "FeatureCollection",
features: [
{
type: "Feature",
geometry: {
type: "Polygon",
coordinates: [[
[10, -80],
[-80, -80],
[-80, 80],
[40, 80],
[40, -20],
[100, -20],
[100, -80],
[30, -80],
[30, -74],
[34, -74],
[34, -68],
[40, -68],
[40, -74],
[94, -74],
[94, -26],
[40, -26],
[40, -60],
[34, -60],
[34, 74],
[-74, 74],
[-74, 30],
[10, 30],
[10, 24],
[-74, 24],
[-74, -24],
[10, -24],
[10, -30],
[-74, -30],
[-74, -74],
[10, -74]
]]
}
}
]
};
let roomsData: FeatureCollection = {
type: "FeatureCollection",
features: [
{
type: "Feature",
properties: {
name: "Room 1",
square: 576
},
geometry: {
type: "Polygon",
coordinates: [[
[-74, -30],
[34, -30],
[34, -74],
[-74, -74]
]]
}
}, {
type: "Feature",
properties: {
name: "Room 2",
square: 600
},
geometry: {
type: "Polygon",
coordinates: [[
[-74, 24],
[34, 24],
[34, -24],
[-74, -24]
]]
}
}, {
type: "Feature",
properties: {
name: "Room 3",
square: 540
},
geometry: {
type: "Polygon",
coordinates: [[
[-74, 74],
[34, 74],
[34, 30],
[-74, 30]
]]
}
}, {
type: "Feature",
properties: {
name: "Room 4",
square: 288
},
geometry: {
type: "Polygon",
coordinates: [[
[40, -26],
[94, -26],
[94, -74],
[40, -74]
]]
}
}
]
};
@Injectable()
export class Service {
getBuildingData(): FeatureCollection {
return buildingData;
}
getRoomsData(): FeatureCollection {
return roomsData;
}
}
// In real applications, you should not transpile code in the browser. You can see how to create your own application with Angular and DevExtreme here:
// https://js.devexpress.com/Documentation/Guide/Angular_Components/Getting_Started/Create_a_DevExtreme_Application/
System.config({
transpiler: 'ts',
typescriptOptions: {
module: "commonjs",
emitDecoratorMetadata: true,
experimentalDecorators: true
},
meta: {
'typescript': {
"exports": "ts"
}
},
paths: {
'npm:': 'https://unpkg.com/'
},
map: {
'ts': 'npm:plugin-typescript@8.0.0/lib/plugin.js',
'typescript': 'npm:typescript@3.4.5/lib/typescript.js',
'@angular/core': 'npm:@angular/core@8.0.0/bundles/core.umd.js',
'@angular/common': 'npm:@angular/common@8.0.0/bundles/common.umd.js',
'@angular/compiler': 'npm:@angular/compiler@8.0.0/bundles/compiler.umd.js',
'@angular/platform-browser': 'npm:@angular/platform-browser@8.0.0/bundles/platform-browser.umd.js',
'@angular/platform-browser-dynamic': 'npm:@angular/platform-browser-dynamic@8.0.0/bundles/platform-browser-dynamic.umd.js',
'@angular/router': 'npm:@angular/router@8.0.0/bundles/router.umd.js',
'@angular/forms': 'npm:@angular/forms@8.0.0/bundles/forms.umd.js',
'@angular/common/http': 'npm:@angular/common@8.0.0/bundles/common-http.umd.js',
'tslib': 'npm:tslib/tslib.js',
'rxjs': 'npm:rxjs@6.3.3',
'rxjs/operators': 'npm:rxjs@6.3.3/operators',
'devextreme': 'npm:devextreme@19.2',
'jszip': 'npm:jszip@3.1.3/dist/jszip.min.js',
'quill': 'npm:quill@1.3.7/dist/quill.js',
'devexpress-diagram': 'npm:devexpress-diagram',
'devexpress-gantt': 'npm:devexpress-gantt',
'devextreme-angular': 'npm:devextreme-angular@19.2'
},
packages: {
'app': {
main: './app.component.ts',
defaultExtension: 'ts'
},
'devextreme': {
defaultExtension: 'js'
},
'rxjs': { main: 'index.js', defaultExtension: 'js' },
'rxjs/operators': { main: 'index.js', defaultExtension: 'js' },
'devextreme-angular': {
main: 'index.js',
defaultExtension: 'js'
}
}
});
<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=1.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/19.2.4/css/dx.common.css" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/19.2.4/css/dx.light.css" />
<script src="https://unpkg.com/core-js@2.4.1/client/shim.min.js"></script>
<script src="https://unpkg.com/zone.js@0.6.25/dist/zone.js"></script>
<script src="https://unpkg.com/reflect-metadata@0.1.3/Reflect.js"></script>
<script src="https://unpkg.com/systemjs@0.21.3/dist/system.js"></script>
<script src="config.js"></script>
<script>
System.import('app').catch(console.error.bind(console));
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<demo-app>Loading...</demo-app>
</div>
</body>
</html>

<template>
<DxVectorMap
id="vector-map"
:max-zoom-factor="4"
:projection="projection"
>
<DxLayer
:data-source="buildingData"
:hover-enabled="false"
name="building"
/>
<DxLayer
:data-source="roomsData"
:border-width="1"
name="rooms"
color="transparent"
>
<DxLabel
:enabled="true"
data-field="name"
/>
</DxLayer>
<DxTooltip
:enabled="true"
:customize-tooltip="customizeTooltip"
/>
</DxVectorMap>
</template>
<script>
import {
DxVectorMap,
DxLayer,
DxLabel,
DxTooltip
} from 'devextreme-vue/vector-map';
import { roomsData, buildingData } from './data.js';
export default {
components: {
DxVectorMap,
DxLayer,
DxLabel,
DxTooltip
},
data() {
return {
roomsData,
buildingData,
projection: {
to: ([l, lt]) => [l / 100, lt / 100],
from: ([x, y]) => [x * 100, y * 100]
}
};
},
methods: {
customizeTooltip(info) {
if (info.layer.name === 'rooms') {
return { text: `Square: ${info.attribute('square')} ft²` };
}
}
}
};
</script>
<style>
#vector-map {
height: 400px;
}
</style>
import { createApp } from 'vue';
import App from './App.vue';
createApp(App).mount('#app');
<!DOCTYPE html>
<html>
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=1.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/20.2.4/css/dx.common.css" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/20.2.4/css/dx.light.css" />
<script src="https://unpkg.com/core-js@2.4.1/client/shim.min.js"></script>
<script src="https://unpkg.com/systemjs@0.21.3/dist/system.js"></script>
<script type="text/javascript" src="config.js"></script>
<script type="text/javascript">
System.import('./index.js');
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<div id="app"></div>
</div>
</body>
</html>
export const buildingData = {
type: 'FeatureCollection',
features: [
{
type: 'Feature',
geometry: {
type: 'Polygon',
coordinates: [[
[10, -80],
[-80, -80],
[-80, 80],
[40, 80],
[40, -20],
[100, -20],
[100, -80],
[30, -80],
[30, -74],
[34, -74],
[34, -68],
[40, -68],
[40, -74],
[94, -74],
[94, -26],
[40, -26],
[40, -60],
[34, -60],
[34, 74],
[-74, 74],
[-74, 30],
[10, 30],
[10, 24],
[-74, 24],
[-74, -24],
[10, -24],
[10, -30],
[-74, -30],
[-74, -74],
[10, -74]
]]
}
}
]
};
export const roomsData = {
type: 'FeatureCollection',
features: [
{
type: 'Feature',
properties: {
name: 'Room 1',
square: 576
},
geometry: {
type: 'Polygon',
coordinates: [[
[-74, -30],
[34, -30],
[34, -74],
[-74, -74]
]]
}
}, {
type: 'Feature',
properties: {
name: 'Room 2',
square: 600
},
geometry: {
type: 'Polygon',
coordinates: [[
[-74, 24],
[34, 24],
[34, -24],
[-74, -24]
]]
}
}, {
type: 'Feature',
properties: {
name: 'Room 3',
square: 540
},
geometry: {
type: 'Polygon',
coordinates: [[
[-74, 74],
[34, 74],
[34, 30],
[-74, 30]
]]
}
}, {
type: 'Feature',
properties: {
name: 'Room 4',
square: 288
},
geometry: {
type: 'Polygon',
coordinates: [[
[40, -26],
[94, -26],
[94, -74],
[40, -74]
]]
}
}
]
};
System.config({
transpiler: 'plugin-babel',
meta: {
'*.vue': {
loader: 'vue-loader'
},
'devextreme/dist/js/vectormap-data/*': {
'esModule': true
},
},
paths: {
'npm:': 'https://unpkg.com/'
},
map: {
'vue': 'npm:vue@3.0.0/dist/vue.esm-browser.js',
'vue-loader': 'npm:dx-systemjs-vue-browser@1.0.15/index.js',
'devextreme/dist/js/vectormap-data': 'js/vectormap-data',
'mitt': 'npm:mitt/dist/mitt.umd.js',
'rrule': 'npm:rrule@2.6.6/dist/es5/rrule.js',
'luxon': 'npm:luxon@1.25.0/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign@1.1.0',
'devextreme': 'npm:devextreme@20.2.4',
'devextreme-vue': 'npm:devextreme-vue@20.2.4',
'jszip': 'npm:jszip@3.5.0/dist/jszip.min.js',
'devextreme-quill': 'npm:devextreme-quill@0.9.7/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.0.5/dist/dx-diagram.js',
'devexpress-gantt': 'npm:devexpress-gantt@2.0.8/dist/dx-gantt.js',
'preact': 'npm:preact@10.5.7/dist/preact.js',
'preact/hooks': 'npm:preact@10.5.7/hooks/dist/hooks.js',
'plugin-babel': 'npm:systemjs-plugin-babel@0.0.25/plugin-babel.js',
'systemjs-babel-build': 'npm:systemjs-plugin-babel@0.0.25/systemjs-babel-browser.js'
},
packages: {
'devextreme-vue': {
main: 'index.js'
},
'devextreme': {
defaultExtension: 'js'
},
'devextreme/events/utils': {
main: 'index'
},
'devextreme/events': {
main: 'index'
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js'
}
},
babelOptions: {
sourceMaps: false,
stage0: true
}
});

import React from 'react';
import VectorMap, {
Layer,
Tooltip,
Label,
} from 'devextreme-react/vector-map';
import { roomsData, buildingData } from './data.js';
const projection = {
to: ([l, lt]) => [l / 100, lt / 100],
from: ([x, y]) => [x * 100, y * 100],
};
export default function App() {
return (
<VectorMap
id="vector-map"
maxZoomFactor={4}
projection={projection}
>
<Layer
dataSource={buildingData}
hoverEnabled={false}
name="building">
</Layer>
<Layer
dataSource={roomsData}
name="rooms"
borderWidth={1}
color="transparent">
<Label enabled={true} dataField="name"></Label>
</Layer>
<Tooltip
enabled={true}
customizeTooltip={customizeTooltip}
></Tooltip>
</VectorMap>
);
}
function customizeTooltip(arg) {
if (arg.layer.name === 'rooms') {
return { text: `Square: ${arg.attribute('square')} ft²` };
}
return null;
}
import React from 'react';
import ReactDOM from 'react-dom';
import App from './App.js';
ReactDOM.render(
<App />,
document.getElementById('app'),
);
<!DOCTYPE html>
<html>
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=1.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/21.2.7/css/dx.common.css" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/21.2.7/css/dx.light.css" />
<link rel="stylesheet" type="text/css" href="styles.css" />
<script src="https://unpkg.com/core-js@2.4.1/client/shim.min.js"></script>
<script src="https://unpkg.com/systemjs@0.21.3/dist/system.js"></script>
<script type="text/javascript" src="config.js"></script>
<script type="text/javascript">
System.import("./index.js");
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<div id="app"></div>
</div>
</body>
</html>
#vector-map {
height: 400px;
}
export const buildingData = {
type: 'FeatureCollection',
features: [
{
type: 'Feature',
geometry: {
type: 'Polygon',
coordinates: [[
[10, -80],
[-80, -80],
[-80, 80],
[40, 80],
[40, -20],
[100, -20],
[100, -80],
[30, -80],
[30, -74],
[34, -74],
[34, -68],
[40, -68],
[40, -74],
[94, -74],
[94, -26],
[40, -26],
[40, -60],
[34, -60],
[34, 74],
[-74, 74],
[-74, 30],
[10, 30],
[10, 24],
[-74, 24],
[-74, -24],
[10, -24],
[10, -30],
[-74, -30],
[-74, -74],
[10, -74],
]],
},
},
],
};
export const roomsData = {
type: 'FeatureCollection',
features: [
{
type: 'Feature',
properties: {
name: 'Room 1',
square: 576,
},
geometry: {
type: 'Polygon',
coordinates: [[
[-74, -30],
[34, -30],
[34, -74],
[-74, -74],
]],
},
}, {
type: 'Feature',
properties: {
name: 'Room 2',
square: 600,
},
geometry: {
type: 'Polygon',
coordinates: [[
[-74, 24],
[34, 24],
[34, -24],
[-74, -24],
]],
},
}, {
type: 'Feature',
properties: {
name: 'Room 3',
square: 540,
},
geometry: {
type: 'Polygon',
coordinates: [[
[-74, 74],
[34, 74],
[34, 30],
[-74, 30],
]],
},
}, {
type: 'Feature',
properties: {
name: 'Room 4',
square: 288,
},
geometry: {
type: 'Polygon',
coordinates: [[
[40, -26],
[94, -26],
[94, -74],
[40, -74],
]],
},
},
],
};
window.config = {
transpiler: 'plugin-babel',
meta: {
'devextreme/localization.js': {
'esModule': true,
},
'devextreme/dist/js/vectormap-data/*': {
'esModule': true,
},
},
paths: {
'npm:': 'https://unpkg.com/',
},
defaultExtension: 'js',
map: {
'react': 'npm:react@17.0.2/umd/react.development.js',
'react-dom': 'npm:react-dom@17.0.2/umd/react-dom.development.js',
'prop-types': 'npm:prop-types@15.8.1/prop-types.js',
'devextreme/dist/js/vectormap-data': 'js/vectormap-data',
'rrule': 'npm:rrule@2.6.6/dist/es5/rrule.js',
'luxon': 'npm:luxon@1.28.0/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign@1.1.0',
'devextreme': 'npm:devextreme@21.2.7/cjs',
'devextreme-react': 'npm:devextreme-react@21.2.7',
'jszip': 'npm:jszip@3.7.1/dist/jszip.min.js',
'devextreme-quill': 'npm:devextreme-quill@1.5.14/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.1.47/dist/dx-diagram.js',
'devexpress-gantt': 'npm:devexpress-gantt@4.0.13/dist/dx-gantt.js',
'@devextreme/runtime': 'npm:@devextreme/runtime@2.3.14',
'inferno': 'npm:inferno@7.4.11/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat@7.4.11/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@7.4.11/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate@7.4.11/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode@7.4.11/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class@7.4.11/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras@7.4.11/dist/inferno-extras.min.js',
// SystemJS plugins
'plugin-babel': 'npm:systemjs-plugin-babel@0.0.25/plugin-babel.js',
'systemjs-babel-build': 'npm:systemjs-plugin-babel@0.0.25/systemjs-babel-browser.js',
},
packages: {
'devextreme': {
defaultExtension: 'js',
},
'devextreme-react': {
main: 'index.js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/events': {
main: 'index',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
'npm:@devextreme/runtime@2.3.14/inferno/package.json',
],
babelOptions: {
sourceMaps: false,
stage0: true,
react: true,
},
};
System.config(window.config);